MAKEPPCLEAN(1)

NAME
makeppclean -- Stand-alone cleanup script for makepp

DESCRIPTION
?: -?, A: -A,
  --args-file,
  --arguments-file, B: -b,
  --build-cache-links, D: -d, E: --empty-directories, H: -h,
  --help, K: -k,
  --keep-src-info, L: -l,
  --leave-src-info,
  --log, M: -m,
  --makepp,
  $MAKEPPCLEANFLAGS,
  --meta, O: --only-build-cache-links,
  --only-logs,
  --only-meta,
  --only-repository-links, R: -R,
  -r,
  --recurse,
  --recursive,
  --repository-links, V: -V,
  -v,
  --verbose,
  --version

makeppclean [ -b ] [ -l ] [ -R ] [ -r ] [ -v ] [ path ... ]

mppc [ -b ] [ -l ] [ -R ] [ -r ] [ -v ] [ path ... ]

Makeppclean efficiently removes files that were knowingly generated through makepp. For each path, if path is not a directory and was known to be generated by makepp by virtue of having a build info file with a matching signature, then remove path and its build info file; and if path is a directory, do the same for every file in path, and then remove the build info directory below path. path defaults to ".".

The traditional approach to removing generated files is to create a "clean" target in your makefiles whose action is to remove all of the targets. This approach has some fundamental limitations:

•   It requires that all the relevant makefiles be loaded before cleaning. This can take quite a while.

•   If the clean target in one makefile depends on the clean target in another makefile, then it is possible that a file that must be built in order to load one of the makefiles (e.g. because of a prebuild statement) has already been built and cleaned by the time it needs to be built again. Makepp wisely fails in this situation, rather than potentially building the same file many times during the course of a single build.

Provided that your intention is to remove all the generated files without regard for which makefile (if any) currently generates them, then these limitations are avoided by using makeppclean.

OPTIONS

-A filename
--args-file=filename
--arguments-file=filename
    Read the file and parse it as possibly quoted whitespace- and/or newline-separated options.

-b
--build-cache-links
--only-build-cache-links
    Remove only links or files from a build cache.

-d
--empty-directories
    Remove directories that became empty after removing their content. Since directories are not usually created by rules, makepp does not keep track of which one it created. Therefore this applies to those, where makepp created something, whether the directory was created manually or automatically.

-?
-h
--help
    Print out a brief summary of the options.

-k
--keep-src-info
--leave-src-info
    Leave the build info directory below each named directory.

-l
--log
--only-logs
    Remove only the raw logfiles, which can be many in case of traditional recursion.

-m
--meta
--only-meta
--makepp
    Remove only the meta information subdirectories.

-R
--repository-links
--only-repository-links
    Remove only links pointing to a repository.

-r
--recurse
--recursive
    Descend each named directory recursively. Symbolic links are not followed.

-v
--verbose
    Enable verbose output to STDERR.

-V
--version
    Print out the version number.

ENVIRONMENT
Makeppclean looks at the following environment variable:

$MAKEPPCLEANFLAGS
    Any flags in this environment variable are interpreted as command line options before any explicit options. Quotes are interpreted like in makefiles.

AUTHOR
Anders Johnson <anders@ieee.org>